UVA1213 Sum of Different Primes(素数打表+dp)

UVA - 1213

Sum of Different Primes

Time Limit: 3000MS   Memory Limit: Unknown   64bit IO Format: %lld & %llu

Submit Status

Description

A positive integer may be expressed as a sum of different prime numbers (primes), in one way or another. Given two positive integers n andk,
you should count the number of ways to express n as a sum of k different primes. Here, two ways are considered to be the same if they sum up the same set of the primes. For example, 8 can
be expressed as 3 + 5 and 5 + 3 but they are not distinguished.

When n and k are 24 and 3 respectively, the answer is two because there are two sets {2,
3, 19} and {2, 5, 17} whose sums are equal to 24. There are no other sets of three primes that sum up to 24. For n = 24 and k =
2, the answer is three, because there are three sets {5, 19}, {7, 17} and {11, 13}. For n = 2 and k = 1,
the answer is one, because there is only one set {2} whose sum is 2. For n = 1 and k = 1, the answer is zero. As 1 is
not a prime, you shouldn‘t count {1}. For n = 4 and k = 2, the answer is zero, because there are no sets of two different primes whose sums are 4.

Your job is to write a program that reports the number of such ways for the given n and k.

Input

The input is a sequence of datasets followed by a line containing two zeros separated by a space. A dataset is a line containing two positive integers n and k separated
by a space. You may assume that n1120 and k14.

Output

The output should be composed of lines, each corresponding to an input dataset. An output line should contain one non-negative integer indicating the number of ways for n and k specified
in the corresponding dataset. You may assume that it is less than 231.

Sample Input

24 3
24 2
2 1
1 1
4 2
18 3
17 1
17 3
17 4
100 5
1000 10
1120 14
0 0

Sample Output

2
3
1
0
0
2
1
0
1
55
200102899
2079324314

Source

Root :: AOAPC II: Beginning Algorithm Contests (Second Edition) (Rujia Liu) :: Chapter 10. Maths :: Exercises

Root :: Competitive Programming 2: This increases the lower bound of Programming Contests. Again (Steven & Felix Halim) :: Problem Solving Paradigms :: Dynamic Programming :: 0-1
Knapsack (Subset Sum)

Root :: Competitive Programming 3: The New Lower Bound of Programming Contests (Steven & Felix Halim) :: Problem Solving Paradigms :: Dynamic Programming :: 0-1
Knapsack (Subset Sum)

Submit Status

题意是选择k个质数使其和为n,先搞一个素数表然后dp,dp[i][j]表示选了j个数和位i的方案数。

#include <bits/stdc++.h>
#define foreach(it,v) for(__typeof((v).begin()) it = (v).begin(); it != (v).end(); ++it)
using namespace std;
typedef long long ll;
const int maxn = 1120;
bool check[maxn];
int prime[1120];
ll dp[1122][15];
int init(int n)
{
    memset(check,0,sizeof check);
    int tot = 0;
    check[0] = check[1] = 1;
    for(int i = 2; i <= n; i++) {
        if(!check[i])prime[tot++] = i;
        for(int j = 0; j < tot; ++j) {
            if((ll)i*prime[j]>n)break;
            check[i*prime[j]] = true;
            if(i%prime[j]==0)break;
        }
    }
    return tot;
}
int main()
{
    int n,k;
    int tot = init(maxn-1);
    while(~scanf("%d%d",&n,&k)&&n) {
       memset(dp,0,sizeof dp);
       dp[0][0] = 1;
       for(int i = 0; prime[i]<=n&&i < tot; i++) {
            int limt = min(i+1,k);
            int w = prime[i];
            for(int V = n; V >= w; V--)
            for(int j = 1; j <= limt; j++)if(dp[V-w][j-1]){
                dp[V][j] += dp[V-w][j-1];
            }
       }
       cout<<dp[n][k]<<endl;
    }
    return 0;
}
时间: 2024-10-09 07:46:36

UVA1213 Sum of Different Primes(素数打表+dp)的相关文章

UVA1213Sum of Different Primes(素数打表 + DP)

题目链接 题意:选择k个素数,使得和为N(1120)的方案数: 筛选出 <= N 的素数,然后就背包 写的时候没初始dp[0][0] = 1;而且方案数也没相加,真是弱逼 #include <iostream> #include <cstdio> #include <algorithm> #include <cstring> using namespace std; const int Max = 1120; int prime[Max + 5], t

hdu 2161 Primes 素数打表

在kuangbin带你飞专题看到的,水了一发,但是wa了一次,T了一次,竟然连素数打表都快不会写了. 而且连求素数时候只需到根号n就可以都忘了,假设有因子m大于√n,那么n/m一定小于√n,所以它在√n前面已经被选出来了. 代码: #include<iostream> #include<cstdio> #include<cstdlib> #include<cstring> #include<cmath> #include<vector>

UVa1213 - Sum of Different Primes(素数表+DP)

题意是选择k个质数使其和为n,先搞一个素数表然后dp,dp[i][j]表示选了j个数和位i的方案数. #include<bits/stdc++.h> using namespace std; typedef long long ll; const int maxn = 1120; bool check[maxn]; int prime[1120]; ll dp[1122][15]; int init(int n){ memset(check,0,sizeof(check)); int tot=

HDOJ(HDU) 2161 Primes(素数打表)

Problem Description Write a program to read in a list of integers and determine whether or not each number is prime. A number, n, is prime if its only divisors are 1 and n. For this problem, the numbers 1 and 2 are not considered primes. Input Each i

[UVa1213]Sum of Different Primes(递推,01背包)

题目链接:https://uva.onlinejudge.org/index.php?option=com_onlinejudge&Itemid=8&page=show_problem&problem=3654 题意:把n拆成k个不同素数的和,有多少种拆法. dp(i,j)表示数字为i时,有j个不同素数和的组合数. 先枚举素数的上界k,注意是不同素数,那就再在k个素数中做01背包,dp(i,j)+=dp(i-p,j-1)统计出现次数就行了. 1 #include <bits/

hdu 3092 (简化的素数打表+dp+log的用法) ps(开数组和预处理时数组要大点处理多一点。。。)

题意:给你一个3000以内的数s,让你把它分解成几个数的和,要求得到的这几个数最小公倍数最大 对于两个数a,b,如果不互质那么对于答案的贡献最多是a*b,假设他们最大公约数为k,那么把a,b分为a,b/k,b-b/k三个数的积肯定会大于等于a*b: 因为当b/k > 1 && b-b/k > 1时, (b/k-1)(b-b/k-1) >= 1. 即b*(b-b/k) >= b.而当b/k==1时那就是a*b==a*(b-b/k)*k; 所以相对肯定是两两互质对答案贡

HDU 4715 Difference Between Primes (素数表+二分)

Difference Between Primes Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 2998    Accepted Submission(s): 850 Problem Description All you know Goldbach conjecture.That is to say, Every even inte

POJ 2739 Sum of Consecutive Prime Numbers【素数打表】

解题思路:给定一个数,判定它由几个连续的素数构成,输出这样的种数 用的筛法素数打表 Sum of Consecutive Prime Numbers Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 20020   Accepted: 10966 Description Some positive integers can be represented by a sum of one or more consecutive

Sum of Consecutive Prime Numbers(素数打表+尺取)

Description Some positive integers can be represented by a sum of one or more consecutive prime numbers. How many such representations does a given positive integer have? For example, the integer 53 has two representations 5 + 7 + 11 + 13 + 17 and 53